package com.bull.cimero.pluginEditor.editors.model.SEModel;

import com.bull.cimero.pluginEditor.editors.model.GeneriqueCimeroModel;

/**
 * This class is the ServiceENgine class. All the service engine of the model
 * must to extends this class.
 * @author Cedric MOUILLERON
 * @author Pierre NOTEL
 * @author Andrea Zoppello (andrea.zoppello@eng.it)
 */
public abstract class ServiceEngineModel extends GeneriqueCimeroModel {


	/**
	 * default constructor.
	 * @param name : model name
	 * @param nbOutputs : nb of outputs are possible
	 * @param nbInputs : nb of inputs are possible
	 */
	public ServiceEngineModel(
			final String name, final int nbOutputs, final int nbInputs) {
		super(name, nbOutputs, nbInputs);
	}

	/** serial uid. */
	private static final long serialVersionUID = 1L;

	/**
	 * method to determine if model is input.
	 * @return boolean
	 */
	public final boolean isInput() {
		return true;
	}

	/**
	 * method to determine if model is output.
	 * @return boolean
	 */
	public final boolean isOutput() {
		return true;
	}

}
