package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;
import java.net.*;

public class _jet_cxfbcbus implements JET2Template {

    public _jet_cxfbcbus() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	String keyStore = JBIJetUtils.getOptionalPropertyValue(aStep, "KeyStore", null);
	String trustStore = JBIJetUtils.getOptionalPropertyValue(aStep, "TrustStore", null);
	
	String keyStorePass = null;
	String keyStoreType = null;
	String trustStorePass = null;
	String trustStoreType = null;
	
	if (keyStore != null){
	
		keyStorePass = JBIJetUtils.getRequiredPropertyValue(aStep, "KeyStorePassword");
		keyStoreType = JBIJetUtils.getOptionalPropertyValue(aStep, "KeyStoreType", "JKS");
	
	}
	
	if ( trustStore != null ){
	
		trustStorePass = JBIJetUtils.getRequiredPropertyValue(aStep, "TrustStorePassword");
		trustStoreType = JBIJetUtils.getOptionalPropertyValue(aStep, "TrustStoreType", "JKS");	
	}
	
	String locationURI = JBIJetUtils.getRequiredPropertyValue(aStep, "Uri");
	int port = 80; //default
	try{
		URL url = new URL(locationURI);
		port = url.getPort();
	}catch (MalformedURLException e) {
		throw new RuntimeException(e);
	}
	
	// We Must understand if it's a pipeline transfomer
   	String isPipelineTransformer = JBIJetUtils.getOptionalPropertyValue(aStep, "IsTransformerPipeline", "false");
	boolean flagTransformerPipeline = Boolean.valueOf(isPipelineTransformer);
	
	String role = "consumer";
   	if (bindingName.equalsIgnoreCase("JBI-CXF-OutputBindingComponent") || (flagTransformerPipeline)){
   		role = "provider";
   	}

        out.write("<beans xmlns=\"http://www.springframework.org/schema/beans\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  xmlns:sec=\"http://cxf.apache.org/configuration/security\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  xmlns:http=\"http://cxf.apache.org/transports/http/configuration\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  xmlns:httpj=\"http://cxf.apache.org/transports/http-jetty/configuration\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  xmlns:jaxws=\"http://java.sun.com/xml/ns/jaxws\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  xsi:schemaLocation=\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t\t   http://cxf.apache.org/configuration/security");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t\t      http://cxf.apache.org/schemas/configuration/security.xsd");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("           http://cxf.apache.org/transports/http/configuration");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("              http://cxf.apache.org/schemas/configuration/http-conf.xsd");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t    http://cxf.apache.org/transports/http-jetty/configuration");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("              http://cxf.apache.org/schemas/configuration/http-jetty.xsd");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("           http://www.springframework.org/schema/beans");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("              http://www.springframework.org/schema/beans/spring-beans-2.0.xsd\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         

	
	

	if (role.equalsIgnoreCase("consumer")){ 
        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t<http:destination name=\"{");  //$NON-NLS-1$        
        out.write(SpagicUtils.getNameSpaceForProcess(aProcess));
        out.write("}");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess,aStep));
        out.write(".http-destination\">   ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("  \t\t</http:destination>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t<httpj:engine-factory bus=\"cxf\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t \t\t<httpj:engine port=\"");  //$NON-NLS-1$        
        out.write(port);
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t     \t\t<httpj:tlsServerParameters>");  //$NON-NLS-1$        
        out.write(NL);         
	} else { 
        out.write("\t\t\t<http:conduit name=\"{");  //$NON-NLS-1$        
        out.write(SpagicUtils.getNameSpaceForProcess(aProcess));
        out.write("}");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess,aStep));
        out.write(".http-conduit\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<http:tlsClientParameters secureSocketProtocol=\"SSL\">");  //$NON-NLS-1$        
        out.write(NL);         
	} 
        out.write("\t  ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t   ");  //$NON-NLS-1$        
        out.write(NL);         
        if ( keyStore != null ) { 
        out.write("\t\t\t ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t <sec:keyManagers keyPassword=\"");  //$NON-NLS-1$        
        out.write(keyStorePass);
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t           <sec:keyStore type=\"");  //$NON-NLS-1$        
        out.write(keyStoreType);
        out.write("\" password=\"");  //$NON-NLS-1$        
        out.write(keyStorePass);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t                resource=\"");  //$NON-NLS-1$        
        out.write(keyStore);
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t      \t </sec:keyManagers>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t      ");  //$NON-NLS-1$        
        out.write(NL);         
		  }
        out.write(NL);         
        if ( trustStore != null ) { 
        out.write("     ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t      \t<sec:trustManagers>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t          <sec:keyStore type=\"");  //$NON-NLS-1$        
        out.write(trustStoreType);
        out.write("\" password=\"");  //$NON-NLS-1$        
        out.write(trustStorePass);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t               resource=\"");  //$NON-NLS-1$        
        out.write(trustStore);
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t      \t</sec:trustManagers>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t      ");  //$NON-NLS-1$        
        out.write(NL);         
      } 		
		if (role.equalsIgnoreCase("consumer")){ 
        out.write("\t   \t\t\t\t</httpj:tlsServerParameters>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t   \t\t\t</httpj:engine>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t   \t\t</httpj:engine-factory>");  //$NON-NLS-1$        
        out.write(NL);         
		} else { 
        out.write("\t\t\t\t</http:tlsClientParameters>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</http:conduit> ");  //$NON-NLS-1$        
        out.write(NL);         
		} 
        out.write("\t ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("</beans>");  //$NON-NLS-1$        
    }
}
